class CreateUnidomCategoryRollups < ActiveRecord::Migration[6.0]

  def change

    create_table :unidom_category_rollups, id: :uuid do |t|

      t.references :ancestor_category,   type: :uuid, null: false,
        foreign_key: false
      t.references :descendant_category, type: :uuid, null: false,
        foreign_key: false

      t.boolean :elemental, null: false, default: false
      t.integer :distance,  null: false, default: 1

      t.column   :state, 'char(1)', null: false, default: Unidom::Common::STATE
      t.datetime :opened_at,        null: false, default: Unidom::Common::OPENED_AT
      t.datetime :closed_at,        null: false, default: Unidom::Common::CLOSED_AT
      t.boolean  :defunct,          null: false, default: false
      t.jsonb    :notation,         null: false, default: {}

      t.timestamps null: false

    end

    #add_index :unidom_category_rollups, :ancestor_category_id
    #add_index :unidom_category_rollups, :descendant_category_id

  end

end
